/*
    SDP Editor
    Copyright 2006 Martin Storsj

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

    Martin Storsj
    martin@martin.st
*/

#include <avkon.hrh>
#include <aknnotewrappers.h> 

#include "sdpedit.pan"
#include "sdpeditappui.h"
#include "sdpeditappview.h"
#include "sdpedit.hrh"

#include "channelchanger.h"
#include <sdpedit.rsg>
#include <aknquerydialog.h>

void CSdpEditAppUi::ConstructL() {
	BaseConstructL();

	iChannelChanger = CChannelChanger::NewL();

	iAppView = CSdpEditAppView::NewL(ClientRect());
	AddToStackL(iAppView);
}

CSdpEditAppUi::CSdpEditAppUi()	{
	iHandle = 0x10000;
	iChannel = 12;
}

CSdpEditAppUi::~CSdpEditAppUi() {
	if (iAppView) {
		iEikonEnv->RemoveFromStack(iAppView);
		delete iAppView;
		iAppView = NULL;
	}
	delete iChannelChanger;
}

void CSdpEditAppUi::HandleCommandL(TInt aCommand) {
	switch(aCommand) {
	case EEikCmdExit:
	case EAknSoftkeyExit:
		TRAPD(err, SaveL());
		Exit();
		break;

	case ESdpEditSetChannel:
		{
		CEikDialog* dlg = CAknMultiLineDataQueryDialog::NewL(iHandle, iChannel);
		if (!dlg->ExecuteLD(R_SDPEDIT_HANDLE_CHANNEL_QUERY))
			break;
		iChannelChanger->UpdateRecordAndReportL(iHandle, iChannel);
//		iChannelChanger->UpdateChannelL();
		}
		break;

	default:
		Panic(ESdpEditUi);
		break;
	}
}

void CSdpEditAppUi::HandleResourceChangeL(TInt aType) {
	CAknAppUi::HandleResourceChangeL(aType);
#ifdef EKA2
	if (aType == KEikDynamicLayoutVariantSwitch) {
		iAppView->SetRect(ClientRect());
	}
#endif
}



